﻿package
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Mouse;

	public class Triangler extends Sprite
	{
		
		private var stack:Array;
		private var max:Number = 1;
		private var maxAngle:Number = 1;
		private var i=Number;
		
		public function Triangler()
		{
			stack = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
		}
		
		private function downHandler(e:MouseEvent):void
		{
			stack[0] = new Point(e.stageX,e.stageY);
			stack[1] = new Point(e.stageX,e.stageY);
			this.graphics.lineStyle(1,Math.random()*0xffffff,1);
			this.graphics.moveTo(e.stageX,e.stageY);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			
		}
		
		private function upHandler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			
		}
		
		private function moveHandler(e:MouseEvent):void
		{
			i=1;
			stack[1].x = e.stageX;
			stack[1].y = e.stageY;
			if(Point.distance(stack[0],stack[1])>=max && checkAngle()%maxAngle<=1){
				stack[0].x = stack[1].x;
				stack[0].y = stack[1].y;				
				//this.graphics.lineTo(stack[1].x,stack[1].y);
				this.graphics.curveTo(mouseX, mouseY, mouseY*i/stack[1].x, mouseX*i/stack[1].y);
				
				i++;
				
			}
			
		}
		
		private function checkAngle():Number
		{
			var dx = stack[1].x - stack[0].x;
			var dy = stack[1].y - stack[0].y;
			
			var reponse = Math.round(Math.atan2(dx,dy)* 360 / Math.PI);
			trace(reponse);
			return reponse;
		}
		
	}
}